PROGRAM FallingBalls(input,output);

CONST

     GravAmount = 1.0;  {this is the amount of fall, per frame per frame }
                        {that gravity will add to our particles' descent }

VAR

   InPos,OutTxt : TEXT;         {Input position file, ISL code out}
   BX,BY,BZ     : REAL;         {Beginning X,Y,Z coordinates from InPos}
   CF,FC,FC2    : INTEGER;      {Current frame (InPos) & frame counter}
   LX,LY,LZ     : REAL;         {Last X,Y,Z}
   TP           : INTEGER;      {Total particle counter}

PROCEDURE DoObject(F:INTEGER);

{write the object information}
{Always use layers when dealing with hundreds of particles!}

BEGIN

WRITELN(OutTxt,'OBJECT "BLIP',F,'" LAYER 1');

{Now the actor -- we want it to fade away in 10 frames.  Use states}

WRITE(OutTxt,'ACTOR FRAMES ',F,' ',F,' NAME "o:wand.lgh" STATE "OPAQUE"');
WRITELN(OutTxt,' CYCLE 0. 0. VELOCITY 1. 1. SPLINE');
WRITE(OutTxt,'ACTOR FRAMES ',F+1,' ',F+9,' NAME "o:wand.lgh" STATE "TRANSP"');
WRITELN(OutTxt,' CYCLE 0. 0. VELOCITY 1. 1. SPLINE');

END; {PROCEDURE DoObject}

PROCEDURE DoAlign(F:INTEGER);

{Now pick a random starting alignment, and a random ending alignment     }
{that way the blip will sort of tumble.  We could use the ROTATE effect, }
{but then leeches who don't pay their shareware fee won't be able to use }
{this code :)                                                            }

BEGIN
WRITE(OutTxt,'ALIGN FRAMES ',F,' ',F,' XYZ ');
WRITE(OutTxt,RANDOM(360),'. ',RANDOM(360),'. ',RANDOM(360));
WRITELN(OutTxt,'. VELOCITY 1. 1. SPLINE');
WRITE(OutTxt,'ALIGN FRAMES ',F+1,' ',F+9,' XYZ ');
WRITE(OutTxt,RANDOM(360),'. ',RANDOM(360),'. ',RANDOM(360));
WRITELN(OutTxt,'. VELOCITY 1. 1. SPLINE');

WRITELN(OutTxt,'SIZE FRAMES ',F,' ',F,' XYZ 2. 2. 2. VELOCITY 1. 1. SPLINE');

WRITELN(OutTxt,' ');

END; {Procedure DoAlign}

PROCEDURE DropIt(F:INTEGER;SX,SY,SZ : REAL); {frame#,Start X,Y,Z}

{This is the workhorse - drop the particle.  It calculates a random X-Y   }
{translation vector, and does the gravity drop thing on the particle      }
VAR
   i,j : INTEGER;               {Counters}
   CrX,CrY,CrZ     : REAL;         {Current X,Y,Z coordinates}
   DX,DY        : REAL;         {Delta X,Y for random movement}
   SZx,SZr          : REAL;          {Starting Z random component}

BEGIN

CrX := SX+RANDOM(8)-4;  {offset the particle a bit from the tip  }
CrY := SY+random(8)-4;  {of the wand}
SZx := (RANDOM(100)/100)*(LZ-SZ);
SZr := (RANDOM(150))/150 -0.75;
CrZ := SZ + SZx + SZr;


DX := (20.-RANDOM(40))/10;     {random delta for X,Y movement}
DY := (20.-RANDOM(40))/10;


FOR  i := 0 TO 9 DO     {Do 10 frames}
     BEGIN
     WRITE(OutTxt,'POSITION FRAMES ',F+i,' ',F+i);
     WRITELN(OutTxt,' XYZ ',CrX:4:4,' ',CrY:4:4,' ',CrZ:4:4,' VELOCITY 1. 1. SPLINE');

     {now move things}

     CrZ := CrZ + (1-i)*GravAmount;   {plot it out, the math'll do ya good}
     CrX := CrX + DX;
     CrY := CrY + DY;
     END; {Loop}

END; {PROCEDURE DropIt}

BEGIN {main loop}

ASSIGN(InPos,'Table1.asc');     {name of input coordinate file}
RESET(InPos);
ASSIGN(OutTxt,'ISLCODE');       {name of output ISL code file}
REWRITE(OutTxt);

CF := 0;        {zero current frame counter}
TP := 0;        {zero particle counter}
WHILE NOT EOF(InPos) DO
      BEGIN
      READLN(InPos,BX,BY,BZ);
      IF (CF=0) THEN BEGIN
                     LX := BX;
                     LY := BY;
                     LZ := BZ
                     END;
      INC(CF);
      WRITELN('Doing frame ',CF);
      FC := RANDOM(6)+1;
      FOR FC2 := 1 to FC DO
          BEGIN
          inc(tp);
          DoObject(CF);             {set up the object settings}
          DropIt(CF,BX,BY,BZ);      {do the particle movement  }
          DoAlign(CF);              {finish up the code        }
          END;
      LX :=BX;
      LY :=BY;
      LZ :=BZ
      END;
CLOSE(InPos);
CLOSE(OutTxt);
Writeln('Total particles = ',TP);
END.